<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddVideoDeviceOutput StructType
 * @subpackage Structs
 */
class AddVideoDeviceOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The InstallationStatusMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InstallationStatusMessage;
    /**
     * The InstallationStatusHeaderMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InstallationStatusHeaderMessage;
    /**
     * Constructor method for AddVideoDeviceOutput
     * @uses AddVideoDeviceOutput::setSuccess()
     * @uses AddVideoDeviceOutput::setErrorMessage()
     * @uses AddVideoDeviceOutput::setInstallationStatusMessage()
     * @uses AddVideoDeviceOutput::setInstallationStatusHeaderMessage()
     * @param bool $success
     * @param string $errorMessage
     * @param string $installationStatusMessage
     * @param string $installationStatusHeaderMessage
     */
    public function __construct($success = null, $errorMessage = null, $installationStatusMessage = null, $installationStatusHeaderMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorMessage($errorMessage)
            ->setInstallationStatusMessage($installationStatusMessage)
            ->setInstallationStatusHeaderMessage($installationStatusHeaderMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\AddVideoDeviceOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\AddVideoDeviceOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get InstallationStatusMessage value
     * @return string|null
     */
    public function getInstallationStatusMessage()
    {
        return $this->InstallationStatusMessage;
    }
    /**
     * Set InstallationStatusMessage value
     * @param string $installationStatusMessage
     * @return \CustomerManagement\StructType\AddVideoDeviceOutput
     */
    public function setInstallationStatusMessage($installationStatusMessage = null)
    {
        // validation for constraint: string
        if (!is_null($installationStatusMessage) && !is_string($installationStatusMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($installationStatusMessage, true), gettype($installationStatusMessage)), __LINE__);
        }
        $this->InstallationStatusMessage = $installationStatusMessage;
        return $this;
    }
    /**
     * Get InstallationStatusHeaderMessage value
     * @return string|null
     */
    public function getInstallationStatusHeaderMessage()
    {
        return $this->InstallationStatusHeaderMessage;
    }
    /**
     * Set InstallationStatusHeaderMessage value
     * @param string $installationStatusHeaderMessage
     * @return \CustomerManagement\StructType\AddVideoDeviceOutput
     */
    public function setInstallationStatusHeaderMessage($installationStatusHeaderMessage = null)
    {
        // validation for constraint: string
        if (!is_null($installationStatusHeaderMessage) && !is_string($installationStatusHeaderMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($installationStatusHeaderMessage, true), gettype($installationStatusHeaderMessage)), __LINE__);
        }
        $this->InstallationStatusHeaderMessage = $installationStatusHeaderMessage;
        return $this;
    }
}
